#property copyright "http://www.forex-tsd.com/"
#property link    ""
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  clrRed
#property indicator_color2  clrDodgerBlue
#property indicator_color3  clrDodgerBlue
#property indicator_color4  clrRed
#property indicator_width1  2
#property indicator_width2  1
#property strict
//---- 
extern int                CCI_Period      = 14;             // Cci Period
extern ENUM_APPLIED_PRICE CCI_Price       = PRICE_TYPICAL;  // Cci price TO USE
extern double             CCI_multiplier  = 0.003;          // Cci Multiplier
extern int                MaPeriod        = 14;             // Ma Period
extern ENUM_MA_METHOD     MaMetod         = MODE_SMA;       // Ma Method
extern ENUM_APPLIED_PRICE MaPrice         = PRICE_TYPICAL;  // Ma price to use
extern bool               alertsOn        = true;           // Turn alerts on?
extern bool               alertsOnCurrent = true;           // Alerts on current (still opened) bar?
extern bool               alertsMessage   = true;           // Alerts should display alert message?
extern bool               alertsSound     = true;           // Alerts should play alert sound?
extern bool               alertsPushNotif = false;          // Alerts should send alert notification?
extern bool               alertsEmail     = false;          // Alerts should send alert email?
extern int                ArrowCodeUp     = 233;            // Up Arrow code
extern int                ArrowCodeDn     = 234;            // Down Arrow code
extern double             ArrowGapUp      = 0.5;            // Gap for arrow up        
extern double             ArrowGapDn      = 0.5;            // Gap for arrow down
extern int                ArrowSizeUp     = 1;              // Up Arrow Size 
extern int                ArrowSizeDn     = 1;              // Down Arrow Size


//---- 
double ccima[];
double ma[];
double arrUp[];
double arrDn[];
double trend[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
//---- 
   IndicatorBuffers(5);
   SetIndexBuffer(0,ccima); SetIndexLabel(0,"CCIonMA CCI:("+(string)CCI_Period+"|"+(string)CCI_Price+")("+(string)MaPeriod+")");
   SetIndexBuffer(1,ma);    SetIndexLabel(1,"MA ("+(string)MaPeriod+")"+(string)MaMetod+","+(string)MaPrice+"");
   SetIndexBuffer(2,arrUp); SetIndexStyle(2,DRAW_ARROW,0,ArrowSizeUp); SetIndexArrow(2,ArrowCodeUp);
   SetIndexBuffer(3,arrDn); SetIndexStyle(3,DRAW_ARROW,0,ArrowSizeDn); SetIndexArrow(3,ArrowCodeDn);
   SetIndexBuffer(4,trend);
   IndicatorShortName("CCIonMA "+(string)CCI_Period+";"+(string)MaPeriod+"");
return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int i,counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit = fmin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for(i=limit;i>=0;i--)
   {
      double cci = iCCI(NULL,0,CCI_Period,CCI_Price,i);
      ma[i]      = iMA(NULL,0,MaPeriod,0,MaMetod,MaPrice,i);
      ccima[i]   = cci*CCI_multiplier*Point*MathPow(10,Digits%2)+ ma[i];
      arrUp[i] = EMPTY_VALUE; 
         arrDn[i] = EMPTY_VALUE;
         if (i<Bars-1)
         { 
           trend[i] = trend[i+1];
           if (ccima[i]>ma[i]) trend[i] = 1;
           if (ccima[i]<ma[i]) trend[i] =-1;
         }
         if (i<Bars-1 && trend[i]!= trend[i+1])
         {
            if (trend[i] ==  1) arrUp[i] = Low[i] -iATR(NULL,0,15,i)*ArrowGapUp;
            if (trend[i] == -1) arrDn[i] = High[i]+iATR(NULL,0,15,i)*ArrowGapDn;
          }
       }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("crossing up");
      else  doAlert("crossing down");       
   }   
	return(0);	
   }

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," CCIonMA ",doWhat);
             if (alertsMessage)   Alert(message);
             if (alertsPushNotif) SendNotification(message);
             if (alertsEmail)     SendMail(StringConcatenate(Symbol()," CCIonMA "),message);
             if (alertsSound)     PlaySound("alert2.wav");
      }
}


         

